.386
.MODEL	FLAT,		STDCALL
OPTION	CASEMAP:	NONE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	I N C L U D E						;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//

INCLUDE	\MASM32\INCLUDE\WINDOWS.INC

INCLUDE	\MASM32\INCLUDE\KERNEL32.INC
INCLUDELIB	\MASM32\LIB\KERNEL32.LIB

INCLUDE	\MASM32\INCLUDE\USER32.INC
INCLUDELIB	\MASM32\LIB\USER32.LIB

INCLUDE	\MASM32\INCLUDE\COMCTL32.INC
INCLUDELIB	\MASM32\LIB\COMCTL32.LIB

INCLUDE	\MASM32\INCLUDE\COMDLG32.INC
INCLUDELIB	\MASM32\LIB\COMDLG32.LIB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	T Y P E D E F s						;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
PtrBYTE	TYPEDEF	NEAR PTR BYTE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	PROCEDURE PROTOTYPES					;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
WinMain		PROTO	:DWORD, :DWORD, :DWORD, :DWORD
WinProc		PROTO	:DWORD, :DWORD, :DWORD, :DWORD
Decode		PROTO	:PtrBYTE
;OpenFileDialog	PROTO :PTR BYTE, :PTR BYTE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	D A T A  S E C T I O N					;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
.DATA

WinClassName	DB	"IconExtractor by programmer1989",0
TreeViewClass	DB	"SysTreeView32",0
ButtonClass		DB	"Button",0
RegError		DB	"Failed to register window",0
ErrorTxt		DB	"IconExtractor Error",0
MFile			DB	"File",0
MOpen			DB	"Open",0
MExtract		DB	"Extract",0
MExit			DB	"Exit",0
MAbout		DB	"About",0
AboutTxt		DB	80,113,109,100,110,92,103,25,90,112,22,101,102,98,89,99,81,92,91,82,94,28,35,33,33,0
IInfo			DB	"Icon info",0
OFNMASK		DB	"Acceptable files",0,"*.DLL;*.EXE",0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	D A T A ?  S E C T I O N				;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
.DATA?

hInst		HINSTANCE	?
Hwnd		HWND		?
CmdLine	LPSTR		?
Menu		HMENU		?
Popup		HMENU		?
FileName	DB	50	dup(?)
FilePath	DB	255	dup(?)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	C O D E  S E C T I O N					;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
.CODE

START:

invoke	GetModuleHandle,	0
MOV		hInst,	EAX

invoke	GetCommandLine
MOV		CmdLine,	EAX

invoke	WinMain,	hInst, 0, ADDR CmdLine, SW_SHOWDEFAULT
invoke	ExitProcess,	EAX
invoke	InitCommonControls
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	W i n M a i n						;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;/
WinMain	PROC	hInstance: HINSTANCE, hPrevInst: HINSTANCE, CommandLine: LPSTR, ShowMode: DWORD

LOCAL		wc:	WNDCLASSEX
LOCAL		msg:	MSG

MOV	wc.cbSize,	SIZEOF WNDCLASSEX
MOV	wc.style,	0
MOV	wc.lpfnWndProc, OFFSET WinProc;
MOV	wc.cbClsExtra,	0
MOV	wc.cbWndExtra,	0
PUSH	hInstance
POP	wc.hInstance
MOV	wc.hbrBackground,	COLOR_BTNFACE+1
MOV	wc.lpszMenuName,	0
MOV	wc.lpszClassName,	OFFSET WinClassName
invoke	LoadIcon, 0, IDI_APPLICATION
MOV	wc.hIcon,	EAX
MOV	wc.hIconSm,	EAX
invoke	LoadCursor, 0, IDC_ARROW
MOV	wc.hCursor,	EAX

invoke	RegisterClassEx, ADDR wc
.IF	EAX == 0
	invoke	MessageBox, 0, ADDR RegError, ADDR ErrorTxt, MB_OK OR MB_ICONERROR
	ret
.ENDIF

;;###############################################
;;	Create main window
invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ADDR WinClassName, ADDR WinClassName, WS_VISIBLE OR WS_SYSMENU OR WS_MINIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, 300, 200, 0, 0, hInstance, 0
MOV	Hwnd,	EAX

;;###############################################
;;	And other controls
invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ADDR TreeViewClass, 0, WS_CHILD OR WS_VISIBLE , 0, 0, 100, 152, Hwnd, 200, hInstance, 0
invoke	CreateWindowEx, 0, ADDR ButtonClass, 0, WS_VISIBLE OR WS_CHILD OR BS_PUSHBUTTON, 100, 0, 190, 80, Hwnd, 201, hInstance, 0
invoke	CreateWindowEx, 0, ADDR ButtonClass, ADDR IInfo, WS_VISIBLE OR WS_CHILD OR BS_GROUPBOX, 100, 80, 190, 72, Hwnd, 201, hInstance, 0

;;###############################################
;;	adding menu
invoke	CreatePopupMenu		;	Create Pop-up menu & main menu handles
MOV	Popup, EAX
invoke	CreateMenu
MOV	Menu, EAX

invoke	AppendMenu, Popup, MF_ENABLED, 100, ADDR MOpen		;#############################
invoke	AppendMenu, Popup, MF_STRING, 101, ADDR MExtract	; Create File menu item
invoke	AppendMenu, Popup, MF_SEPARATOR, 0, 0
invoke	AppendMenu, Popup, MF_ENABLED, 102, ADDR MExit
invoke	AppendMenu, Menu, MF_POPUP, Popup, ADDR MFile

invoke	AppendMenu, Menu,MF_STRING, 103, ADDR MAbout		; Create About menu item

invoke	SetMenu, Hwnd, Menu

invoke	ShowWindow, Hwnd, ShowMode
invoke	UpdateWindow, Hwnd

.WHILE TRUE
	invoke GetMessage, ADDR msg, 0, 0, 0
	.BREAK .IF (!EAX)
	invoke TranslateMessage, ADDR msg
	invoke DispatchMessage, ADDR msg
.ENDW

ret
WinMain	ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	W i n P r o c						;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
WinProc	PROC	hwnd: HWND, msg:	UINT, wPar: WPARAM, lPar: LPARAM
.IF	msg == WM_CLOSE
	invoke	PostQuitMessage, 0
.ELSEIF	msg == WM_CREATE
	invoke	Decode, ADDR AboutTxt
.ELSEIF	msg == WM_COMMAND
	.IF	wPar == 102
		invoke	PostQuitMessage, 0
	.ELSEIF	wPar == 103
		invoke	MessageBox, Hwnd, ADDR AboutTxt, ADDR WinClassName, MB_ICONINFORMATION
	.ENDIF
.ELSE
	invoke	DefWindowProc, hwnd, msg, wPar, lPar
	ret
.ENDIF

XOR	EAX,	EAX
ret
WinProc	ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	D e c o d e 						;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;//
Decode	PROC	USES ECX EDI,	Txt:	PtrBYTE
LOCAL VarToAdd:	BYTE
XOR	ECX,	ECX
XOR	EAX,	EAX
MOV	EDI,  Txt
DLoop:
	cmp	Txt[ECX], 0
	JE	DEnd
	ADD	BYTE PTR[EDI][ECX], AL 
	INC	ECX
	INC	AL
	JMP	DLoop
DEnd:
invoke	MessageBox, 0, Txt, Txt, MB_OK
RET
Decode ENDP

OpenFileDialog 	PROC	FN:	PTR BYTE, FP:	PTR BYTE
	LOCAL ofn:	OPENFILENAME
	MOV	ofn.lStructSize, SIZEOF ofn
	MOV	ofn.hInstance, 0
	MOV	ofn.lpstrFilter, OFFSET OFNMASK
	MOV	ofn.lpstrCustomFilter, 0
	PUSH	FP
	POP	ofn.lpstrFile
	MOV	ofn.nMaxFile, SIZEOF FP
	PUSH	FN
	POP	ofn.lpstrFileTitle
	MOV	ofn.nMaxFileTitle, SIZEOF FN
	MOV	ofn.Flags, OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
	invoke	GetOpenFileName, ADDR ofn
RET
OpenFileDialog	ENDP
END START